package cars
{

import flash.display.Shape;
import flash.text.TextLineMetrics;

import mx.controls.Label;
import mx.core.UIComponent;

public class CarShape extends UIComponent
{
	public var carWidth:uint;
	public var carHeight:uint;
	
	public var labelColor:Number;

	public var carAlpha:Number;
	
	private var _label:String;
	private var _carShape:Shape;
	private var _carLabel:Label;
	private var _carColor:uint;
	
	public function CarShape()
	{
		super();
		
		carWidth = 24;
		carHeight = 43;
		_carColor = 0x882222;
		labelColor = 0xffffff;
	}
	
	public function set carColor(carColor:uint):void
	{
		if (_carShape)
		{
			removeChild(_carShape);
		}
		_carColor = carColor;
		
		createCar();
		
		invalidateDisplayList();
	}
	public function get carColor():uint
	{
		return _carColor;
	}
	
	public function set label(_label:String):void
	{
	  this._label = _label;
	  
	  if (_carLabel != null)
	  {
	    _carLabel.text = _label;
	  }
	}
  public function get label():String
  {
    return _label;
  }
  
  public function rotateCar(angle:Number):void
  {
    _carShape.rotation = angle;
  }
	
	override protected function measure():void
	{
		super.measure();
    
    width = measuredWidth = measuredMinWidth = Math.max(carWidth, carHeight);
    height = measuredHeight = measuredMinHeight = width;
	}
	
	override protected function createChildren():void
	{
    super.createChildren();
    	
    createCar();
		
		if (!_carLabel)
		{
			_carLabel = new Label();
			_carLabel.setStyle("color", labelColor);
			_carLabel.setStyle("fontSize", 11);
			_carLabel.setStyle("fontWeight", "bold");
			_carLabel.setStyle("fontFamily", "Arial");
			if (label != "")
			{
				_carLabel.text = label;
			}
			addChild(_carLabel);
		}
 	}
 
	override protected function updateDisplayList(unscaledWidth:Number, unscaledHeight:Number):void
	{
    super.updateDisplayList(unscaledWidth, unscaledHeight);
    
    var lineMetrics:TextLineMetrics = measureText(_carLabel.text);

    _carLabel.setActualSize(unscaledWidth, unscaledHeight);
    _carLabel.move( -1 - (lineMetrics.width / 2), -1 - (lineMetrics.height / 2));
	}
	
  override protected function commitProperties():void
  {
    super.commitProperties();
    
    invalidateDisplayList();
  }
  
  private function createCar():void
  {
  	if (!_carShape)
  	{
    	_carShape = new Shape();
    	_carShape.graphics.beginFill(carColor, carAlpha);
    	_carShape.graphics.drawRoundRect((carWidth / 2) * -1, (carHeight / 2) * -1, carWidth, carHeight, 10, 10);
    	addChildAt(_carShape, 0);
    }
  }

}
}